#!/usr/bin/perl
# Program prmruje detrendovan kivky zskan vi jednotlivm srovnvacm
# hvzdm pi pozorovn tranzitu exoplanety. 
#
# ZPSOB POUIT: > fittool.pl 2455388 comp1.txt comp2.txt comp3.txt ...
# 
# Prvn parametr je base JD. Celoseln st JD pozorovac noci. Tato
# hodnota bude pitena ke zlomku JD v prvnm sloupci ve vstupnm souboru.
# Obsah soubor comp1.txt, comp2.txt atd. zskte uloenm
# obsahu textovho pole pod kivkou ve fitovtku TRESCA ve ASCII 
# formtu. Soubory mus bt v adresi spolu se skriptem.
# Pro prmrovn je poui sloupec MAG-TREND, tedy detrendovan
# svteln kivka a normovan na hotnotu 0.00000 mag mimo tranzit.
# Program vechny kivky slo na sebe a tento vsledek vype
# v souboru "allcomps.txt". 
# Nsledn program zprmruje aritmetickm prmrem vechna data
# do prmrn svteln kivky a data ulo do souboru "allcomps_average.txt"
# Tato vsledn zprmrovan data vlote do finlnho protokolu TRESCA.
#
#
$outfile = "allcomps.txt";
$outfile_average = "allcomps_average.txt";
#
######## DO NOT EDIT BELLOW THIS LINE ###########################################

$pocet_souboru = @ARGV;

$j = 0;
open (OUT, ">".$outfile) || die $!;
for ($i = 1; $i<$pocet_souboru; ++$i) {
	open (F, "<".$ARGV[$i]) || die $!;
	while (<F>) {
		chop; 
		if ($_ =~ /^\d+/) {
			($jd, $mag, $mag_fit, $mag_mag_fit, $rescaled_error, $mag_trend, $mag_fit_trend) = split (/\s+/, $_);
			$jd += $ARGV[0];
			print OUT $jd."\t".$mag_trend."\n";
			$data[$j] = $jd."\t".$mag_trend;
			++$j;
		}
	}
	close(F);
}
close(OUT);
@data_sorted = sort(@data);
open (AVE, ">".$outfile_average) || die $!;
$n = 0; $tmpmag = 0;
foreach $line (@data_sorted) {
	($jd, $mag) = split (/\t/, $line);
	if (($jd == $lastjd) || (!$lastjd)) { 
		$tmpmag += $mag;
		++$n;
	} else { 
		$mag_ave = $tmpmag / $n;
		print AVE $lastjd."\t".sprintf("%.5f", $mag_ave)."\n";
		$n = 0; $tmpmag = 0;
		$tmpmag += $mag;
		++$n;
	}
	$lastjd = $jd;
}	
	if ($n > 0) {
		$mag_ave = $tmpmag / $n;
		print AVE $lastjd."\t".sprintf("%.5f", $mag_ave)."\n";
	}

close (AVE);

